#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_S1"]
	#Text["Robot Dreams [r]A spell card full of cute paterns"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	let BGM = CSD ~ "./SFX/withered leaf.mp3";
	
	@Initialize{
		SetAutoDeleteObject(true);
	
		let objScene = GetEnemyBossSceneObjectID();
		ObjEnemyBossScene_StartSpell(objScene);

		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetDestAtWeight(objEnemy,190,80,8,5);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(6000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(60);
		}
		case(EV_REQUEST_SPELL_SCORE) {
			SetScriptResult(200000);
		}
	}
	
	task movement{
		Cutin(objEnemy,"Robot Dreams",1);
		wait(120);
		PlaySound(PowerUp);
		loop(90){
			TChargeEffect(ex,ey,1);
			wait(1);}
		Fire1;
	}

	task Fire1{
		let B = rand(0,360);
		let C = 60;
		let angle= 0;
		loop{
			DeleteShotAll(TYPE_SHOT, TYPE_FADE);
			Fire2;
			loop(24){
				PlaySound(Attack5);
				while (angle<360){
					ShootShape(ex+C*sin(angle+B),ey-C*cos(angle+B), 0.9, angle+B, 4, 3, rand(38,40), 24);
					TExplodeEffect(ex+C*sin(angle+B),ey-C*cos(angle+B),1);
					angle+=360/4;
				}
				angle=0;
				B+=1.6*6;
				C = C + 1.6*12;
				wait(3);
			}
			ObjMove_SetDestAtWeight(objEnemy,rand(GetClipMinX+100,GetClipMaxX-100),rand(20,160),15,6);
			wait(240);
		
			DeleteShotAll(TYPE_SHOT, TYPE_FADE);
			loop(24){TChargeEffect(ex,ey,1);}
			Fire2;
			B = rand(0,360);
			C = 60;
			loop(24){
				PlaySound(Attack5);
				while (angle<360){
					ShootShape(ex+C*sin(angle+B),ey-C*cos(angle+B), 0.9, angle+B, 4, 3, rand(38,40), 24);
					TExplodeEffect(ex+C*sin(angle+B),ey-C*cos(angle+B),1);
					angle+=360/4;
				}
				angle=0;
				B-=1.6*6;
				C = C + 1.6*12;
				wait(3);
			}
			ObjMove_SetDestAtWeight(objEnemy,rand(GetClipMinX+100,GetClipMaxX-100),rand(20,160),15,6);
			B = rand(0,360);
			C = 60;
			wait(240);
			yield;
			loop(24){TChargeEffect(ex,ey,1);}
		}
	}

	task Fire2{
		let angle = 0;
		let B = rand(0,360);
			PlaySound(Twinkle);
		loop(55){
			let obj1 = CreateShotA2(ex+30*sin(angle+B),ey-30*cos(angle+B),5,angle+B-90,-0.2,0.7,222,12);
			let obj2 = CreateShotA2(ex+30*sin(angle+B),ey-30*cos(angle+B),5,angle+B-90,-0.2,0.7,220,0);

			let obj3 = CreateShotA2(ex+30*sin(angle+B+185),ey-30*cos(angle+B+185),3,angle+B-90+185,-0.2,0.8,222,12);
			let obj4 = CreateShotA2(ex+30*sin(angle+B+185),ey-30*cos(angle+B+185),3,angle+B-90+185,-0.2,0.8,220,0);

			ObjShot_SetSpellResist(obj1,true);
			ObjShot_SetSpellResist(obj2,true);
			ObjShot_SetSpellResist(obj3,true);
			ObjShot_SetSpellResist(obj4,true);
			angle+=360/36;
			yield;
		}
	}
	
	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}
		
		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		loop(5){TExplodeEffect(ex,ey,1);}
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}